diff --git a/meta/recipes-support/lz4/files/0001-tests-Makefile-don-t-use-LIBDIR-as-variable.patch b/meta/recipes-support/lz4/files/0001-tests-Makefile-don-t-use-LIBDIR-as-variable.patch
deleted file mode 100644
index 00494e8..0000000
--- a/meta/recipes-support/lz4/files/0001-tests-Makefile-don-t-use-LIBDIR-as-variable.patch
+++ /dev/null
@@ -1,82 +0,0 @@
-From d4768d9e29b805096a86aa13c0d30ee8215af4df Mon Sep 17 00:00:00 2001
-From: Jussi Kukkonen <jussi.kukkonen@intel.com>
-Date: Mon, 26 Jun 2017 12:07:09 +0300
-Subject: [PATCH] tests/Makefile: don't use LIBDIR as variable
-
-LIBDIR may be overriden with a environment variable: In this case make
-clean breaks. Use another variable name.
-
-Signed-off-by: Jussi Kukkonen <jussi.kukkonen@intel.com>
-Upstream-Status: Backport
----
- tests/Makefile | 26 +++++++++++++-------------
- 1 file changed, 13 insertions(+), 13 deletions(-)
-
-diff --git a/tests/Makefile b/tests/Makefile
-index 97fa782..51dd038 100644
---- a/tests/Makefile
-+++ b/tests/Makefile
-@@ -32,7 +32,7 @@ DESTDIR ?=
- PREFIX  ?= /usr/local
- BINDIR  := $(PREFIX)/bin
- MANDIR  := $(PREFIX)/share/man/man1
--LIBDIR  := ../lib
-+LZ4DIR  := ../lib
- PRGDIR  := ../programs
- VOID    := /dev/null
- TESTDIR := versionsTest
-@@ -43,7 +43,7 @@ CFLAGS  += -g -Wall -Wextra -Wundef -Wcast-qual -Wcast-align -Wshadow -Wswitch-e
-            -Wdeclaration-after-statement -Wstrict-prototypes \
-            -Wpointer-arith -Wstrict-aliasing=1
- CFLAGS  += $(MOREFLAGS)
--CPPFLAGS:= -I$(LIBDIR) -I$(PRGDIR) -DXXH_NAMESPACE=LZ4_
-+CPPFLAGS:= -I$(LZ4DIR) -I$(PRGDIR) -DXXH_NAMESPACE=LZ4_
- FLAGS    = $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
- 
- 
-@@ -79,31 +79,31 @@ lz4c32:   # create a 32-bits version for 32/64 interop tests
- 	$(MAKE) -C $(PRGDIR) clean $@ CFLAGS="-m32 $(CFLAGS)"
- 	cp $(LZ4) $(LZ4)c32
- 
--fullbench  : $(LIBDIR)/lz4.o $(LIBDIR)/lz4hc.o $(LIBDIR)/lz4frame.o $(LIBDIR)/xxhash.o fullbench.c
-+fullbench  : $(LZ4DIR)/lz4.o $(LZ4DIR)/lz4hc.o $(LZ4DIR)/lz4frame.o $(LZ4DIR)/xxhash.o fullbench.c
- 	$(CC) $(FLAGS) $^ -o $@$(EXT)
- 
--fullbench-lib: fullbench.c $(LIBDIR)/xxhash.c
--	$(MAKE) -C $(LIBDIR) liblz4.a
--	$(CC) $(FLAGS) $^ -o $@$(EXT) $(LIBDIR)/liblz4.a
-+fullbench-lib: fullbench.c $(LZ4DIR)/xxhash.c
-+	$(MAKE) -C $(LZ4DIR) liblz4.a
-+	$(CC) $(FLAGS) $^ -o $@$(EXT) $(LZ4DIR)/liblz4.a
- 
--fullbench-dll: fullbench.c $(LIBDIR)/xxhash.c
--	$(MAKE) -C $(LIBDIR) liblz4
--	$(CC) $(FLAGS) $^ -o $@$(EXT) -DLZ4_DLL_IMPORT=1 $(LIBDIR)/dll/liblz4.dll
-+fullbench-dll: fullbench.c $(LZ4DIR)/xxhash.c
-+	$(MAKE) -C $(LZ4DIR) liblz4
-+	$(CC) $(FLAGS) $^ -o $@$(EXT) -DLZ4_DLL_IMPORT=1 $(LZ4DIR)/dll/liblz4.dll
- 
--fuzzer  : $(LIBDIR)/lz4.o $(LIBDIR)/lz4hc.o $(LIBDIR)/xxhash.o fuzzer.c
-+fuzzer  : $(LZ4DIR)/lz4.o $(LZ4DIR)/lz4hc.o $(LZ4DIR)/xxhash.o fuzzer.c
- 	$(CC) $(FLAGS) $^ -o $@$(EXT)
- 
--frametest: $(LIBDIR)/lz4frame.o $(LIBDIR)/lz4.o $(LIBDIR)/lz4hc.o $(LIBDIR)/xxhash.o frametest.c
-+frametest: $(LZ4DIR)/lz4frame.o $(LZ4DIR)/lz4.o $(LZ4DIR)/lz4hc.o $(LZ4DIR)/xxhash.o frametest.c
- 	$(CC) $(FLAGS) $^ -o $@$(EXT)
- 
--fasttest: $(LIBDIR)/lz4.o fasttest.c
-+fasttest: $(LZ4DIR)/lz4.o fasttest.c
- 	$(CC) $(FLAGS) $^ -o $@$(EXT)
- 
- datagen : $(PRGDIR)/datagen.c datagencli.c
- 	$(CC) $(FLAGS) -I$(PRGDIR) $^ -o $@$(EXT)
- 
- clean:
--	@$(MAKE) -C $(LIBDIR) $@ > $(VOID)
-+	@$(MAKE) -C $(LZ4DIR) $@ > $(VOID)
- 	@$(MAKE) -C $(PRGDIR) $@ > $(VOID)
- 	@$(RM) core *.o *.test tmp* \
-         fullbench-dll$(EXT) fullbench-lib$(EXT) \
--- 
-2.1.4
-
diff --git a/meta/recipes-support/lz4/lz4_1.7.4.bb b/meta/recipes-support/lz4/lz4_1.8.1.2.bb
similarity index 79%
rename from meta/recipes-support/lz4/lz4_1.7.4.bb
rename to meta/recipes-support/lz4/lz4_1.8.1.2.bb
index 86a1ab9..03017b3 100644
--- a/meta/recipes-support/lz4/lz4_1.7.4.bb
+++ b/meta/recipes-support/lz4/lz4_1.8.1.2.bb
@@ -2,18 +2,18 @@ SUMMARY = "Extremely Fast Compression algorithm"
 DESCRIPTION = "LZ4 is a very fast lossless compression algorithm, providing compression speed at 400 MB/s per core, scalable with multi-cores CPU. It also features an extremely fast decoder, with speed in multiple GB/s per core, typically reaching RAM speed limits on multi-core systems."
 
 LICENSE = "BSD | BSD-2-Clause | GPL-2.0"
-LIC_FILES_CHKSUM = "file://lib/LICENSE;md5=ebc2ea4814a64de7708f1571904b32cc\
+LIC_FILES_CHKSUM = "file://lib/LICENSE;md5=ebc2ea4814a64de7708f1571904b32cc \
                     file://programs/COPYING;md5=b234ee4d69f5fce4486a80fdaf4a4263 \
-                    file://LICENSE;md5=7f2857d58beff6d04137bf9b09e5ffb6"
+                    file://LICENSE;md5=d57c0d21cb917fb4e0af2454aa48b956 \
+                    "
 
 PE = "1"
 
-SRCREV = "7bb64ff2b69a9f8367de9ab483cdadf42b4c1b65"
+SRCREV = "dfed9fa1d77f0434306d377c4da1f7191d3ba08a"
 
 SRC_URI = "git://github.com/lz4/lz4.git \
-           file://0001-tests-Makefile-don-t-use-LIBDIR-as-variable.patch \
            file://run-ptest \
-"
+           "
 UPSTREAM_CHECK_GITTAGREGEX = "v(?P<pver>.*)"
 
 S = "${WORKDIR}/git"